Bug 1271944 - Review Request: gspell - Spell-checking library for GTK+
Review Request: gspell - Spell-checking library for GTK+
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Michael Catanzaro
Fedora Extras Quality Assurance
: EasyFix
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-10-15 02:44 EDT by Kalev Lember
Modified: 2015-12-07 15:07 EST (History)
5 users (show)

See Also:
Fixed In Version: gspell-0.1.2-1.fc23
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2015-12-07 15:07:37 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---
mcatanzaro: fedora‑review+


Attachments (Terms of Use)

  None (edit)
Description Kalev Lember 2015-10-15 02:44:38 EDT
Spec URL: https://kalev.fedorapeople.org/gspell.spec
SRPM URL: https://kalev.fedorapeople.org/gspell-0.1.0-1.fc23.src.rpm
Description:
gspell provides a flexible API to implement the spell checking
in a GTK+ application.

Fedora Account System Username: kalev

koji scratch build: http://koji.fedoraproject.org/koji/taskinfo?taskID=11454524
Comment 1 Upstream Release Monitoring 2015-10-15 02:48:34 EDT
kalev's scratch build of gspell-0.1.0-1.fc23.src.rpm for f23 completed http://koji.fedoraproject.org/koji/taskinfo?taskID=11454524
Comment 2 Michael Catanzaro 2015-11-27 21:40:20 EST
Thanks for packaging this! I have two [?] questions in the MUST items that I'd like answers for before accepting this. I also have three [!] fails under SHOULD items.


Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated



===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Header files in -devel subpackage, if present.
[x]: ldconfig called in %post and %postun if required.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
[x]: Development (unversioned) .so files in -devel subpackage, if present.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "GPL", "GPL (v2 or later)", "Unknown or generated", "MIT/X11
     (BSD like)", "GPL (v3 or later) GPL (v3 or later)", "LGPL (v2.1 or
     later)". 159 files have unknown license. Detailed output of
     licensecheck in /home/mcatanzaro/1271944-gspell/licensecheck.txt
[x]: License file installed when any subpackage combination is installed.
[?]: Package does not own files or directories owned by other packages.
     Note: Below is the output of fedora-review, but I don't understand this
     requirement at all. The packaging guidelines require that the package own
     the directories that it installs files into, so this checkbox seems to be
     completely impossible to fulfill. Am I reading this too literally?
     Note: Dirs in package are owned also by: /usr/share/gir-1.0(gobject-
     introspection-devel, libgnome-keyring-devel, GConf2-devel, gtk2-devel,
     gcr-devel, gtk3-devel, atk-devel, gdk-pixbuf2-devel, libxklavier-
     devel), /usr/share/gtk-doc(libgweather-devel, libcanberra-devel,
     libgnome-keyring-devel, libgda-devel, gtk3-devel-docs, libxklavier-
     devel, gcr-devel, polkit-docs, poppler-devel, harfbuzz-devel,
     libsecret-devel, json-glib-devel, gtk2-devel-docs, libgdata-devel,
     gnome-desktop3-devel, p11-kit-devel, gtk-doc, gtkspell3-devel),
     /usr/share/vala/vapi(gmime-devel, libcanberra-devel, libgnome-keyring-
     devel, pulseaudio-libs-devel, vala, gcr-devel, libgexiv2-devel,
     libgweather-devel, libgdata-devel, libsoup-devel), /usr/share/gtk-
     doc/html(libgweather-devel, libcanberra-devel, libgnome-keyring-devel,
     libgda-devel, gtk3-devel-docs, libxklavier-devel, gcr-devel, polkit-
     docs, poppler-devel, harfbuzz-devel, libsecret-devel, json-glib-devel,
     gtk2-devel-docs, libgdata-devel, gnome-desktop3-devel, p11-kit-devel,
     gtk-doc, gtkspell3-devel), /usr/lib64/girepository-1.0(gobject-
     introspection, libxklavier, GConf2, libgnome-keyring, gdk-pixbuf2,
     libgtop2, atk, gtk2, gtk3, vte3, gcr, libgee, vte291, gfbgraph,
     libzapojit, gucharmap-libs, gsound), /usr/share/vala(gmime-devel,
     libcanberra-devel, libgnome-keyring-devel, pulseaudio-libs-devel,
     vala, gcr-devel, libgexiv2-devel, libgweather-devel, libgdata-devel,
     libsoup-devel)
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: The spec file handles locales properly.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[?]: Requires correct, justified where necessary.
     Note: I don't understand the decision to explicitly require glib2, gtk3,
     and gtksourceview3. Is it just to ensure the installed versions are not
     older than the version it was built against? Why did you do this for those
     dependencies but not the others?
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 0 bytes in 0 files.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in gspell-
     doc , gspell-debuginfo
[x]: Package functions as described.
[!]: Latest version is packaged.
     Note: Latest version is 0.2.1.
[x]: Package does not include license text files separate from upstream.
[x]: Scriptlets must be sane, if used.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[!]: %check is present and all tests pass.
     Note: It has a simple little test; couldn't hurt to run it.
[!]: Packages should try to preserve timestamps of original installed
     files.
     Note: To hit this you would replace use of %{make_install} with
     make install DESTDIR=$RPM_BUILD_ROOT INSTALL="install -p" since
     %{make_install} doesn't use -p. But personally, I would rather use the
     macro and expect the macro to be fixed, than to write out that long mess.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: The placement of pkgconfig(.pc) files are correct.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on debuginfo package(s).
     Note: No rpmlint messages.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: gspell-0.1.0-1.fc22.x86_64.rpm
          gspell-devel-0.1.0-1.fc22.x86_64.rpm
          gspell-doc-0.1.0-1.fc22.noarch.rpm
          gspell-debuginfo-0.1.0-1.fc22.x86_64.rpm
          gspell-0.1.0-1.fc22.src.rpm
gspell.x86_64: W: no-documentation
gspell-devel.x86_64: W: only-non-binary-in-usr-lib
gspell-devel.x86_64: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 3 warnings.




Rpmlint (debuginfo)
-------------------
Checking: gspell-debuginfo-0.1.0-1.fc22.x86_64.rpm
1 packages and 0 specfiles checked; 0 errors, 0 warnings.





Rpmlint (installed packages)
----------------------------
gspell-devel.x86_64: W: only-non-binary-in-usr-lib
gspell-devel.x86_64: W: no-documentation
gspell.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgspell-1.so.0.0.0 /lib64/libgdk-3.so.0
gspell.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgspell-1.so.0.0.0 /lib64/libpangocairo-1.0.so.0
gspell.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgspell-1.so.0.0.0 /lib64/libpango-1.0.so.0
gspell.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgspell-1.so.0.0.0 /lib64/libatk-1.0.so.0
gspell.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgspell-1.so.0.0.0 /lib64/libcairo-gobject.so.2
gspell.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgspell-1.so.0.0.0 /lib64/libcairo.so.2
gspell.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgspell-1.so.0.0.0 /lib64/libgdk_pixbuf-2.0.so.0
gspell.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgspell-1.so.0.0.0 /lib64/libgmodule-2.0.so.0
gspell.x86_64: W: unused-direct-shlib-dependency /usr/lib64/libgspell-1.so.0.0.0 /lib64/libpthread.so.0
gspell.x86_64: W: no-documentation
4 packages and 0 specfiles checked; 0 errors, 12 warnings.



Requires
--------
gspell-devel (rpmlib, GLIBC filtered):
    /usr/bin/pkg-config
    gspell(x86-64)
    libgspell-1.so.0()(64bit)
    pkgconfig(enchant)
    pkgconfig(glib-2.0)
    pkgconfig(gtk+-3.0)
    pkgconfig(gtksourceview-3.0)
    pkgconfig(libxml-2.0)

gspell-doc (rpmlib, GLIBC filtered):
    gspell

gspell (rpmlib, GLIBC filtered):
    /sbin/ldconfig
    glib2(x86-64)
    gtk3(x86-64)
    gtksourceview3(x86-64)
    iso-codes
    libatk-1.0.so.0()(64bit)
    libc.so.6()(64bit)
    libcairo-gobject.so.2()(64bit)
    libcairo.so.2()(64bit)
    libenchant.so.1()(64bit)
    libgdk-3.so.0()(64bit)
    libgdk_pixbuf-2.0.so.0()(64bit)
    libgio-2.0.so.0()(64bit)
    libglib-2.0.so.0()(64bit)
    libgmodule-2.0.so.0()(64bit)
    libgobject-2.0.so.0()(64bit)
    libgtk-3.so.0()(64bit)
    libgtksourceview-3.0.so.1()(64bit)
    libpango-1.0.so.0()(64bit)
    libpangocairo-1.0.so.0()(64bit)
    libpthread.so.0()(64bit)
    libxml2.so.2()(64bit)
    libxml2.so.2(LIBXML2_2.4.30)(64bit)
    libxml2.so.2(LIBXML2_2.5.0)(64bit)
    libxml2.so.2(LIBXML2_2.6.0)(64bit)
    rtld(GNU_HASH)

gspell-debuginfo (rpmlib, GLIBC filtered):



Provides
--------
gspell-devel:
    gspell-devel
    gspell-devel(x86-64)
    pkgconfig(gspell-1)

gspell-doc:
    gspell-doc

gspell:
    gspell
    gspell(x86-64)
    libgspell-1.so.0()(64bit)

gspell-debuginfo:
    gspell-debuginfo
    gspell-debuginfo(x86-64)



Source checksums
----------------
https://download.gnome.org/sources/gspell/0.1/gspell-0.1.0.tar.xz :
  CHECKSUM(SHA256) this package     : 8c10c5c447ca8c4a230516bd89bcfb00791fe3b4a7bbd4f34a53c72505db9628
  CHECKSUM(SHA256) upstream package : 8c10c5c447ca8c4a230516bd89bcfb00791fe3b4a7bbd4f34a53c72505db9628


Generated by fedora-review 0.6.0 (3c5c9d7) last change: 2015-05-20
Command line :/usr/bin/fedora-review -b 1271944
Buildroot used: fedora-22-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 3 Kalev Lember 2015-12-06 10:27:16 EST
Ooops, sorry, I missed your comment last week.

The directory ownership thing you pointed out, the main idea there is to ensure that every directory is "owned" by something so that when a package gets uninstalled, it doesn't leave any empty directories behind.

The rule of thumb is that we should always list all directories in %files that the package creates, with two exceptions: 1) leave it out if the directory is included in the 'filesystem' package, 2) leave it out if it's created by something that's in the package's natural dep chain.

https://fedoraproject.org/wiki/Packaging:Guidelines#File_and_Directory_Ownership has some examples, including a gtk-doc example.
Comment 4 Kalev Lember 2015-12-06 11:01:12 EST
> Note: It has a simple little test; couldn't hurt to run it.

Which test do you mean? I can't see anything that resembles a 'make check' style test. tests/test-spell.c has a demo or a code sample or something like that, not a self test that we would be able to run automatically.


Here's an update to the latest 0.1.x version for F23; rawhide would get latest unstable version instead:

* Sun Dec 06 2015 Kalev Lember <klember@redhat.com> - 0.1.2-1
- Update to 0.1.2

Spec URL: https://kalev.fedorapeople.org/gspell.spec
SRPM URL: https://kalev.fedorapeople.org/gspell-0.1.2-1.fc23.src.rpm
Comment 5 Michael Catanzaro 2015-12-06 11:30:44 EST
One remaining question:

[?]: Requires correct, justified where necessary.
     Note: I don't understand the decision to explicitly require glib2, gtk3,
     and gtksourceview3. Is it just to ensure the installed versions are not
     older than the version it was built against? Why did you do this for those
     dependencies but not the others?

(In reply to Kalev Lember from comment #3)
> The rule of thumb is that we should always list all directories in %files
> that the package creates, with two exceptions: 1) leave it out if the
> directory is included in the 'filesystem' package, 2) leave it out if it's
> created by something that's in the package's natural dep chain.

So fedora-review is wrong. :)

(In reply to Kalev Lember from comment #4)
> Which test do you mean? I can't see anything that resembles a 'make check'
> style test. tests/test-spell.c has a demo or a code sample or something like
> that, not a self test that we would be able to run automatically.

Ah, OK.
Comment 6 Michael Catanzaro 2015-12-06 11:32:25 EST
(In reply to Kalev Lember from comment #4)
> Here's an update to the latest 0.1.x version for F23; rawhide would get
> latest unstable version instead:

Why are you packaging it for F23? Are you planning to upgrade LaTeXila?
Comment 7 Kalev Lember 2015-12-06 13:26:53 EST
(In reply to Michael Catanzaro from comment #5)
> One remaining question:
> 
> [?]: Requires correct, justified where necessary.
>      Note: I don't understand the decision to explicitly require glib2, gtk3,
>      and gtksourceview3. Is it just to ensure the installed versions are not
>      older than the version it was built against? Why did you do this for
> those
>      dependencies but not the others?

The versioned requires are there to make sure we get new enough versions with distro upgrades. I only added versions where it seemed like the minimum requirements are newer than what was available in F21.

I normally add versioned dependencies to core packages where we absolutely have to make sure that distro upgrades don't break things, so that the depsolver would know that it needs to update dependencies as well. In less mission critical packages I don't usually bother; I honestly can't remember why I added them here because latexila doesn't sound very mission critical :)

Some other libraries like glibc use symbol versioning, which makes it all automatic and avoids the need to manually specify versions, but sadly we aren't using it in gnome.


(In reply to Michael Catanzaro from comment #6)
> Why are you packaging it for F23? Are you planning to upgrade LaTeXila?

Yes. I packaged it up because it was needed for a latexila 3.17.x development release. In the mean time, F23 release has come and gone and we're now well under way to the 3.19 cycle and gedit has started using it as well.
Comment 8 Michael Catanzaro 2015-12-07 04:54:48 EST
OK, approved! Thanks for packaging!
Comment 9 Kalev Lember 2015-12-07 04:55:17 EST
Great, thanks Michael!
Comment 10 Gwyn Ciesla 2015-12-07 09:40:52 EST
Package request has been approved: https://admin.fedoraproject.org/pkgdb/package/gspell
Comment 11 Kalev Lember 2015-12-07 15:07:37 EST
Package imported and built.

Note You need to log in before you can comment on or make changes to this bug.